use std::env;

mod cipher;

fn main()
{
    let argument_vector : Vec<String> = env::args().collect();

    if argument_vector.len() < 4
    {
        print_usage_message();
        
        return;
    }

    let method   : String = String::from(argument_vector[1].trim());
    let password : String = String::from(argument_vector[2].trim());
    let source   : String = String::from(argument_vector[3].trim());

    let initial_value_byte_vector : Vec<u8> = cipher::get_initial_value_byte_vector();

    let target : String = match &method[..]
    {
        "enc" => cipher::encrypt(&source, &password, &initial_value_byte_vector),

        "dec" => cipher::decrypt(&source, &password, &initial_value_byte_vector),

        _     =>
        {
            print_usage_message();
            
            return;
        }
    };

    println!("{}", target);
}

fn print_usage_message()
{
    println!("[USAGE] test_project (enc|dec) password source");
}